require "Polycode/EventDispatcher"

class "Core" (EventDispatcher)



EVENT_CORE_RESIZE = 0




function Core:Update()
	local retVal =  Polycore.Core_Update(self.__ptr)
	return retVal
end

function Core:enableMouse(newval)
	local retVal = Polycore.Core_enableMouse(self.__ptr, newval)
end

function Core:setCursor(cursorType)
	local retVal = Polycore.Core_setCursor(self.__ptr, cursorType)
end

function Core:warpCursor(x, y)
	local retVal = Polycore.Core_warpCursor(self.__ptr, x, y)
end

function Core:createThread(target)
	local retVal = Polycore.Core_createThread(self.__ptr, target.__ptr)
end

function Core:lockMutex(mutex)
	local retVal = Polycore.Core_lockMutex(self.__ptr, mutex.__ptr)
end

function Core:unlockMutex(mutex)
	local retVal = Polycore.Core_unlockMutex(self.__ptr, mutex.__ptr)
end

function Core:createMutex()
	local retVal =  Polycore.Core_createMutex(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["CoreMutex"][retVal] ~= nil then
		return __ptr_lookup["CoreMutex"][retVal]
	else
		__ptr_lookup["CoreMutex"][retVal] = _G["CoreMutex"]("__skip_ptr__")
		__ptr_lookup["CoreMutex"][retVal].__ptr = retVal
		return __ptr_lookup["CoreMutex"][retVal]
	end
end

function Core:copyStringToClipboard(str)
	local retVal = Polycore.Core_copyStringToClipboard(self.__ptr, str)
end

function Core:getClipboardString()
	local retVal =  Polycore.Core_getClipboardString(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["String"][retVal] ~= nil then
		return __ptr_lookup["String"][retVal]
	else
		__ptr_lookup["String"][retVal] = _G["String"]("__skip_ptr__")
		__ptr_lookup["String"][retVal].__ptr = retVal
		return __ptr_lookup["String"][retVal]
	end
end

function Core:getServices()
	local retVal =  Polycore.Core_getServices(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["CoreServices"][retVal] ~= nil then
		return __ptr_lookup["CoreServices"][retVal]
	else
		__ptr_lookup["CoreServices"][retVal] = _G["CoreServices"]("__skip_ptr__")
		__ptr_lookup["CoreServices"][retVal].__ptr = retVal
		return __ptr_lookup["CoreServices"][retVal]
	end
end

function Core:getFPS()
	local retVal =  Polycore.Core_getFPS(self.__ptr)
	return retVal
end

function Core:Shutdown()
	local retVal =  Polycore.Core_Shutdown(self.__ptr)
end

function Core:isFullscreen()
	local retVal =  Polycore.Core_isFullscreen(self.__ptr)
	return retVal
end

function Core:getAALevel()
	local retVal =  Polycore.Core_getAALevel(self.__ptr)
	return retVal
end

function Core:getInput()
	local retVal =  Polycore.Core_getInput(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["CoreInput"][retVal] ~= nil then
		return __ptr_lookup["CoreInput"][retVal]
	else
		__ptr_lookup["CoreInput"][retVal] = _G["CoreInput"]("__skip_ptr__")
		__ptr_lookup["CoreInput"][retVal].__ptr = retVal
		return __ptr_lookup["CoreInput"][retVal]
	end
end

function Core:getXRes()
	local retVal =  Polycore.Core_getXRes(self.__ptr)
	return retVal
end

function Core:getYRes()
	local retVal =  Polycore.Core_getYRes(self.__ptr)
	return retVal
end

function Core:getNumVideoModes()
	local retVal =  Polycore.Core_getNumVideoModes(self.__ptr)
	return retVal
end

function Core:createFolder(folderPath)
	local retVal = Polycore.Core_createFolder(self.__ptr, folderPath)
end

function Core:copyDiskItem(itemPath, destItemPath)
	local retVal = Polycore.Core_copyDiskItem(self.__ptr, itemPath, destItemPath)
end

function Core:moveDiskItem(itemPath, destItemPath)
	local retVal = Polycore.Core_moveDiskItem(self.__ptr, itemPath, destItemPath)
end

function Core:removeDiskItem(itemPath)
	local retVal = Polycore.Core_removeDiskItem(self.__ptr, itemPath)
end

function Core:openFolderPicker()
	local retVal =  Polycore.Core_openFolderPicker(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["String"][retVal] ~= nil then
		return __ptr_lookup["String"][retVal]
	else
		__ptr_lookup["String"][retVal] = _G["String"]("__skip_ptr__")
		__ptr_lookup["String"][retVal].__ptr = retVal
		return __ptr_lookup["String"][retVal]
	end
end

function Core:setVideoModeIndex(index, fullScreen, vSync, aaLevel, anisotropyLevel)
	local retVal = Polycore.Core_setVideoModeIndex(self.__ptr, index, fullScreen, vSync, aaLevel, anisotropyLevel)
end

function Core:setVideoMode(xRes, yRes, fullScreen, vSync, aaLevel, anisotropyLevel)
	local retVal = Polycore.Core_setVideoMode(self.__ptr, xRes, yRes, fullScreen, vSync, aaLevel, anisotropyLevel)
end

function Core:resizeTo(xRes, yRes)
	local retVal = Polycore.Core_resizeTo(self.__ptr, xRes, yRes)
end

function Core:doSleep()
	local retVal =  Polycore.Core_doSleep(self.__ptr)
end

function Core:openURL(url)
	local retVal = Polycore.Core_openURL(self.__ptr, url)
end

function Core:getElapsed()
	local retVal =  Polycore.Core_getElapsed(self.__ptr)
	return retVal
end

function Core:getTicks()
	local retVal =  Polycore.Core_getTicks(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["unsignedint"][retVal] ~= nil then
		return __ptr_lookup["unsignedint"][retVal]
	else
		__ptr_lookup["unsignedint"][retVal] = _G["unsignedint"]("__skip_ptr__")
		__ptr_lookup["unsignedint"][retVal].__ptr = retVal
		return __ptr_lookup["unsignedint"][retVal]
	end
end

function Core:getTicksFloat()
	local retVal =  Polycore.Core_getTicksFloat(self.__ptr)
	return retVal
end

function Core:setUserPointer(ptr)
	local retVal = Polycore.Core_setUserPointer(self.__ptr, ptr.__ptr)
end

function Core:getUserPointer()
	local retVal =  Polycore.Core_getUserPointer(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["void"][retVal] ~= nil then
		return __ptr_lookup["void"][retVal]
	else
		__ptr_lookup["void"][retVal] = _G["void"]("__skip_ptr__")
		__ptr_lookup["void"][retVal].__ptr = retVal
		return __ptr_lookup["void"][retVal]
	end
end

function Core:getDefaultWorkingDirectory()
	local retVal =  Polycore.Core_getDefaultWorkingDirectory(self.__ptr)
	return retVal
end

function Core:getUserHomeDirectory()
	local retVal =  Polycore.Core_getUserHomeDirectory(self.__ptr)
	return retVal
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.Core = {}

function Core:__delete()
	__ptr_lookup.Core[self.__ptr] = nil
	Polycore.delete_Core(self.__ptr)
end
