require "Polycode/ScreenEntity"

class "ScreenMesh" (ScreenEntity)



function ScreenMesh:__index__(name)
	if name == "lineSmooth" then
		return Polycore.ScreenMesh_get_lineSmooth(self.__ptr)
	elseif name == "lineWidth" then
		return Polycore.ScreenMesh_get_lineWidth(self.__ptr)
	elseif name == "ownsMesh" then
		return Polycore.ScreenMesh_get_ownsMesh(self.__ptr)
	end
end


function ScreenMesh:__set_callback(name,value)
	if name == "lineSmooth" then
		Polycore.ScreenMesh_set_lineSmooth(self.__ptr, value)
		return true
	elseif name == "lineWidth" then
		Polycore.ScreenMesh_set_lineWidth(self.__ptr, value)
		return true
	elseif name == "ownsMesh" then
		Polycore.ScreenMesh_set_ownsMesh(self.__ptr, value)
		return true
	end
	return false
end


function ScreenMesh:ScreenMesh(...)
	if type(arg[1]) == "table" and count(arg) == 1 then
		if ""..arg[1]:class() == "ScreenEntity" then
			self.__ptr = arg[1].__ptr
			return
		end
	end
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Polycore.ScreenMesh(unpack(arg))
		__ptr_lookup.ScreenMesh[self.__ptr] = self
	end
end

function ScreenMesh:Render()
	local retVal =  Polycore.ScreenMesh_Render(self.__ptr)
end

function ScreenMesh:getMesh()
	local retVal =  Polycore.ScreenMesh_getMesh(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Mesh"][retVal] ~= nil then
		return __ptr_lookup["Mesh"][retVal]
	else
		__ptr_lookup["Mesh"][retVal] = _G["Mesh"]("__skip_ptr__")
		__ptr_lookup["Mesh"][retVal].__ptr = retVal
		return __ptr_lookup["Mesh"][retVal]
	end
end

function ScreenMesh:getTexture()
	local retVal =  Polycore.ScreenMesh_getTexture(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Texture"][retVal] ~= nil then
		return __ptr_lookup["Texture"][retVal]
	else
		__ptr_lookup["Texture"][retVal] = _G["Texture"]("__skip_ptr__")
		__ptr_lookup["Texture"][retVal].__ptr = retVal
		return __ptr_lookup["Texture"][retVal]
	end
end

function ScreenMesh:loadTexture(fileName)
	local retVal = Polycore.ScreenMesh_loadTexture(self.__ptr, fileName)
end

function ScreenMesh:setTexture(texture)
	local retVal = Polycore.ScreenMesh_setTexture(self.__ptr, texture.__ptr)
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.ScreenMesh = {}

function ScreenMesh:__delete()
	__ptr_lookup.ScreenMesh[self.__ptr] = nil
	Polycore.delete_ScreenMesh(self.__ptr)
end
