require "Physics3D/CollisionSceneEntity"

class "PhysicsSceneEntity" (CollisionSceneEntity)



SHAPE_BOX = 0
SHAPE_TERRAIN = 1
SHAPE_SPHERE = 2
SHAPE_MESH = 3
CHARACTER_CONTROLLER = 4
SHAPE_CAPSULE = 5
SHAPE_PLANE = 6
SHAPE_CONE = 7
SHAPE_CYLINDER = 8
function PhysicsSceneEntity:__index__(name)
	if name == "enabled" then
		return Physics3D.PhysicsSceneEntity_get_enabled(self.__ptr)
	end
end


function PhysicsSceneEntity:__set_callback(name,value)
	if name == "enabled" then
		Physics3D.PhysicsSceneEntity_set_enabled(self.__ptr, value)
		return true
	end
	return false
end


function PhysicsSceneEntity:PhysicsSceneEntity(...)
	if type(arg[1]) == "table" and count(arg) == 1 then
		if ""..arg[1]:class() == "CollisionSceneEntity" then
			self.__ptr = arg[1].__ptr
			return
		end
	end
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Physics3D.PhysicsSceneEntity(unpack(arg))
		__ptr_lookup.PhysicsSceneEntity[self.__ptr] = self
	end
end

function PhysicsSceneEntity:Update()
	local retVal =  Physics3D.PhysicsSceneEntity_Update(self.__ptr)
end

function PhysicsSceneEntity:getSceneEntity()
	local retVal =  Physics3D.PhysicsSceneEntity_getSceneEntity(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["SceneEntity"][retVal] ~= nil then
		return __ptr_lookup["SceneEntity"][retVal]
	else
		__ptr_lookup["SceneEntity"][retVal] = _G["SceneEntity"]("__skip_ptr__")
		__ptr_lookup["SceneEntity"][retVal].__ptr = retVal
		return __ptr_lookup["SceneEntity"][retVal]
	end
end

function PhysicsSceneEntity:setFriction(friction)
	local retVal = Physics3D.PhysicsSceneEntity_setFriction(self.__ptr, friction)
end

function PhysicsSceneEntity:getType()
	local retVal =  Physics3D.PhysicsSceneEntity_getType(self.__ptr)
	return retVal
end

function PhysicsSceneEntity:setVelocity(velocity)
	local retVal = Physics3D.PhysicsSceneEntity_setVelocity(self.__ptr, velocity.__ptr)
end

function PhysicsSceneEntity:warpTo(position, resetRotation)
	local retVal = Physics3D.PhysicsSceneEntity_warpTo(self.__ptr, position.__ptr, resetRotation)
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.PhysicsSceneEntity = {}

function PhysicsSceneEntity:__delete()
	__ptr_lookup.PhysicsSceneEntity[self.__ptr] = nil
	Physics3D.delete_PhysicsSceneEntity(self.__ptr)
end
